QuantumLeap
QuantumLeap is a REST service for storing, querying and retrieving NGSI v2 and NGSI-LDNGSI-LDAn open API and data model specification for context management, published by ETSI. Stellio implements it. spatio-temporal data.
QuantumLeap converts NGSI semi-structured data into tabular format and stores it in a time-series database, associating each database record with a time index and, if present in the NGSI data, a location on Earth.
If you only need to access the NGSI-LDNGSI-LDAn open API and data model specification for context management, published by ETSI. Stellio implements it. Data via the API, you do not need to activate the QuantumLeap Component. But if you want to access the NGSI-LDNGSI-LDAn open API and data model specification for context management, published by ETSI. Stellio implements it. data directly via database access, then this components helps to create an easy-to-use copy of the data.
Activating the component by configuring the deployment in the inventory is the first step.
The second step is to decide which data should be replicated to QuantumLeap. This is done by creating a subscription in StellioStellioAn NGSI-LD compatible context broker. On the platform, a data space maps to a tenant in Stellio with separate roles for reading, writing, and deleting entities.. QuantumLeap acts as an external consumer for StellioStellioAn NGSI-LD compatible context broker. On the platform, a data space maps to a tenant in Stellio with separate roles for reading, writing, and deleting entities. and must be connected through subscriptions.
The subscription API in detail is described here: Subscriptions
A concrete example (in cURL syntax) of a subscription, that subscribes to all data of one data spaceData spaceA thematic area that contains specific data and resources in different platform components. Data is stored in exactly one data space, and access rights are specific to each data space. Roles within a data space control what users and groups can do in it. looks as follows:
curl --location 'https://api.<domain>/context/ngsi-ld/v1/subscriptions/' \
--header 'fiware-service: ds_protected' \
--header 'Authorization: Bearer <token>' \
--header 'content-type: application/ld+json' \
--data-raw '{
"description": "Persist data to QuantumLeap",
"type": "Subscription",
"entities": [{"type": ".*"}],
"notification": {
"format": "keyValues",
"endpoint": {
"uri": "http://quantumleap.<namespace>.svc.cluster.local:8668/v2/notify",
"accept": "application/json"
}
},
"@context": "http://context-provider:3000/data-models/ngsi-context.jsonld"
} '
The subscription uses the internal URL of QuantumLeap to forward the data.